api/urls.py
urlpatterns = [

]

cmp/urls.py
from django.urls import path, include

from .views import CompraDetDelete, ProveedorView, ProveedorNew, ProveedorEdit, inactivar_proveedor, \
    ComprasView, compras

from .reportes import reporte_compras, imprimir_compra

urlpatterns = [
    path("proveedores/", ProveedorView.as_view(), name="proveedor_list"),
    path("proveedores/new", ProveedorNew.as_view(), name="proveedor_new"),
    path("proveedores/edit/<int:pk>", ProveedorEdit.as_view(), name="proveedor_edit"),
    path("proveedores/inactivar/<int:id>", inactivar_proveedor, name="proveedor_inactivar"),
    path("compras/", ComprasView.as_view(), name="compras_list"),
    path("compras/new", compras, name="compras_new"),
    path("compras/edit/<int:compra_id>", compras, name="compras_edit"),
    path("compras/<int:compra_id>/delete/<int:pk>", CompraDetDelete.as_view(), name="compras_del"),

    path('compras/listado', reporte_compras, name='compras_print_all'),
    path('compras/<int:compra_id>/imprimir', imprimir_compra, name='compras_print_one'),
]

inv/urls.py
from django.urls import path

from inv.models import SubCategoria, UnidadMedida

from .views import CategoriaView, CategoriaNew, CategoriaEdit, CategoriaDel, MarcaView, \
    SubCategoriaView, SubCategoriaNew, SubCategoriaEdit, SubCategoriaDel, \
        MarcaView, MarcaNew, MarcaEdit, marca_inactivar, \
            UMView, UMNew, UMEdit, um_inactivar, \
                ProductoView, ProductoNew, ProductoEdit, producto_inactivar
            

urlpatterns = [
    path('categorias/', CategoriaView.as_view(), name='categoria_list'),
    path('categorias/new', CategoriaNew.as_view(), name='categoria_new'),
    path('categorias/edit/<int:pk>', CategoriaEdit.as_view(), name='categoria_edit'),
    path('categorias/delete/<int:pk>', CategoriaDel.as_view(), name='categoria_del'),

    path('subcategorias/', SubCategoriaView.as_view(), name='subcategoria_list'),
    path('subcategorias/new', SubCategoriaNew.as_view(), name='subcategoria_new'),
    path('subcategorias/edit/<int:pk>', SubCategoriaEdit.as_view(), name='subcategoria_edit'),
    path('subcategorias/delete/<int:pk>', SubCategoriaDel.as_view(), name='subcategoria_del'),

    path('marcas/', MarcaView.as_view(), name='marca_list'),
    path('marcas/new', MarcaNew.as_view(), name='marca_new'),
    path('marcas/edit/<int:pk>', MarcaEdit.as_view(), name='marca_edit'),
    path('marcas/inactivar/<int:id>', marca_inactivar, name='marca_inactivar'),

    path('um/', UMView.as_view(), name='um_list'),
    path('um/new', UMNew.as_view(), name='um_new'),
    path('um/edit/<int:pk>', UMEdit.as_view(), name='um_edit'),
    path('um/inactivar/<int:id>', um_inactivar, name='um_inactivar'),

    path('producto/', ProductoView.as_view(), name='producto_list'),
    path('producto/new', ProductoNew.as_view(), name='producto_new'),
    path('producto/edit/<int:pk>', ProductoEdit.as_view(), name='producto_edit'),
    path('producto/inactivar/<int:id>', producto_inactivar, name='producto_inactivar'),    
]

syscofa/urls.py
from argparse import Namespace
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace='bases')),
    path('inv/', include(('inv.urls', 'inv'), namespace='inv')),
    path('cmp/', include(('cmp.urls', 'cmp'), namespace='cmp')),
    path('fac/', include(('fac.urls', 'fac'), namespace='fac')),
    path('api/', include(('api.urls', 'api'), namespace='api')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls')),    
]

cmp/models.py
from pyexpat import model
from tabnanny import verbose
from tkinter import CASCADE
from django.db import models
from django.db.models import Sum
# para los signals
from django.db.models.signals import post_save, post_delete
from django.dispatch import receiver
from bases.models import ClaseModelo
from inv.models import Producto

# Create your models here.
class Proveedor(ClaseModelo):

    descripcion = models.CharField(
        max_length=100,
        unique=True
    )
    direccion = models.CharField(
        max_length=250,
        null=True,
        blank=True
    )
    contacto = models.CharField(
        max_length=100
    )
    telefono = models.CharField(
        max_length=10,
        null=True,
        blank=True
    )
    email = models.CharField(
        max_length=250,
        null=True,
        blank=True
    )

    def __str__(self):
        return '{}'.format(self.descripcion)

    def save(self):
        self.descripcion = self.descripcion.upper()
        super(Proveedor, self).save()

    class Meta:
        verbose_name_plural = 'Proveedores'

class ComprasEnc(ClaseModelo):
    fecha_compra = models.DateField(null=True, blank=True)
    observacion = models.TextField(null=True, blank=True)
    no_factura = models.CharField(max_length=100)
    fecha_factura =models.DateField()
    sub_total = models.FloatField(default=0)
    descuento = models.FloatField(default=0)
    total = models.FloatField(default=0)

    proveedor = models.ForeignKey(Proveedor, on_delete=models.CASCADE)

    def __str__(self):
        return '{}'.format(self.observacion)

    def save(self):
        self.observacion = self.observacion.upper()
        self.total = self.sub_total - self.descuento
        super(ComprasEnc, self).save()

    class Meta:
        verbose_name_plural = "Encabezado Compras"
        verbose_name = "Encabezado Compra"

class ComprasDet(ClaseModelo):
    compra = models.ForeignKey(ComprasEnc, on_delete=models.CASCADE)
    producto = models.ForeignKey(Producto, on_delete=models.CASCADE)
    cantidad = models.BigIntegerField(default=0)
    precio_prv = models.FloatField(default=0)
    sub_total = models.FloatField(default=0)
    descuento = models.FloatField(default=0)
    total = models.FloatField(default=0)
    costo = models.FloatField(default=0)

    def __str__(self):
        return '{}'.format(self.producto)

    def save(self):
        self.sub_total = float(float(int(self.cantidad)) * float(self.precio_prv)) 
        self.total = self.sub_total - float(self.descuento)
        super(ComprasDet, self).save()

    class Meta:
        verbose_name_plural = "Detalles Compras"
        verbose_name = ("Detalle Compra")

#vigilamos el comprasenc con signals
@receiver(post_delete, sender=ComprasDet)
def detalle_compra_borrar(sender, instance, **kwargs):
    id_producto = instance.producto.id
    id_compra = instance.compra.id

    enc = ComprasEnc.objects.filter(pk=id_compra).first() # si encabezado existe
    if enc:
        sub_total = ComprasDet.objects.filter(compra=id_compra).aggregate(Sum('sub_total'))
        descuento = ComprasDet.objects.filter(compra=id_compra).aggregate(Sum('descuento'))
        enc.sub_total = sub_total['sub_total__sum']
        enc.descuento = descuento['descuento__sum']
        enc.save()

    prod = Producto.objects.filter(pk=id_producto).first() #si producto existe
    if prod:
        cantidad = int(prod.existencia) - int(instance.cantidad)
        prod.existencia = cantidad
        prod.save()

@receiver(post_save, sender=ComprasDet)
def detalle_comopra_guardar(sender, instance, **kwargs):
    id_producto = instance.producto.id
    fecha_compra = instance.compra.fecha_compra

    prod = Producto.objects.filter(pk=id_producto).first()
    if prod: #si encontramos un producto
        cantidad = int(prod.existencia) + int(instance.cantidad)
        prod.ultima_compra = fecha_compra
        prod.existencia = cantidad
        prod.save()

cmp/forms.py
from tkinter import Widget
from django import forms

from .models import Proveedor, ComprasEnc

class ProveedorForm(forms.ModelForm):
    email = forms.EmailField(max_length=254)
    class Meta:
        model = Proveedor
        exclude = ['um', 'fm', 'uc', 'fc']
        widget = {'descripcion': forms.TextInput()}

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            })

class ComprasEncForm(forms.ModelForm):
    fecha_compra = forms.DateInput()
    fecha_factura = forms.DateInput()

    class Meta:
        model = ComprasEnc
        fields = ['proveedor', 'fecha_compra', 'observacion', 'no_factura', 'fecha_factura',
            'sub_total', 'descuento', 'total'
        ]

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            })

        self.fields['fecha_compra'].widget.attrs['readonly'] = True
        self.fields['fecha_factura'].widget.attrs['readonly'] = True
        self.fields['sub_total'].widget.attrs['readonly'] = True
        self.fields['descuento'].widget.attrs['readonly'] = True
        self.fields['total'].widget.attrs['readonly'] = True

    

    

cmp/views.py
from msilib.schema import Class
from re import template
from xmlrpc.client import DateTime
from django.shortcuts import render, redirect
from django.views import generic
from django.urls import reverse_lazy
import datetime
from django.http import HttpResponse

from django.contrib.messages.views import SuccessMessageMixin
from django.http import HttpResponse
import json
from django.db.models import Sum

from django.contrib.auth.decorators import login_required, permission_required

from .models import Proveedor, ComprasEnc, ComprasDet
from .forms import ComprasEncForm
from cmp.models import Producto, ComprasDet
from .forms import ProveedorForm
from bases.views import Sin_Privilegios

# Create your views here.
class ProveedorView(Sin_Privilegios, generic.ListView):
    model = Proveedor
    template_name = "cmp/proveedor_list.html"
    context_object_name = "obj"
    permission_required = 'cmp.view_proveedor'

class ProveedorNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    model = Proveedor
    template_name = "cmp/proveedor_form.html"
    context_object_name = "obj"
    form_class =  ProveedorForm #formulario a utilizar
    success_url = reverse_lazy("cmp:proveedor_list") #redireccionamos a la lista de proveedores
    permission_required = 'cmp.add_proveedor'
    success_message = "Proveedor creado satisfactoriamente"

    def form_valid(self, form):
        form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
        return super().form_valid(form)

class ProveedorEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):    
    model = Proveedor
    template_name = "cmp/proveedor_form.html"
    context_object_name = "obj"
    form_class =  ProveedorForm #formulario a utilizar
    success_url = reverse_lazy("cmp:proveedor_list") #redireccionamos a la lista de proveedores
    permission_required = 'cmp.change_proveedor'
    success_message = "Proveedor actualizado satisfactoriamente"

    def form_valid(self, form):
        form.instance.um = self.request.user.id #ubicamos al usuario que modificó el formulario
        return super().form_valid(form)

@login_required(login_url='/login/') #debo estar logeado
@permission_required('inv.change_marca', login_url='bases:sin_privilegios') # y tener permiso para modificar
def inactivar_proveedor(request, id):
    template_name = "cmp/inactivar_proveedor.html"
    contexto = {}

    proveedor = Proveedor.objects.filter(pk=id).first()
    if not proveedor:
        return HttpResponse('Proveedor no existe' + str(id))

    if request.method == 'GET':
        contexto = {'obj': proveedor}

    if request.method == 'POST':
        proveedor.estado = False
        proveedor.save()
        contexto = {'obj':'OK'}
        return HttpResponse('Proveedor Inactivado')

    return render(request, template_name, contexto)

class ComprasView(Sin_Privilegios, generic.ListView):
    model = ComprasEnc
    template_name = "cmp/compras_list.html"
    context_object_name = "obj"
    permission_required = 'cmp.view_comprasenc'

@login_required(login_url='/login/')
@permission_required('cmp:view_comprasenc', login_url='bases:sin_privilegios')
def compras(request, compra_id=None):
    template_name = 'cmp/compras.html'
    prod = Producto.objects.filter(estado=True)
    form_compras = {}
    contexto = {}

    if request.method == 'GET':
        form_compras = ComprasEncForm()
        enc = ComprasEnc.objects.filter(pk=compra_id).first()

        if enc:
            det = ComprasDet.objects.filter(compra=enc)
            fecha_compra = datetime.date.isoformat(enc.fecha_compra)
            fecha_factura = datetime.date.isoformat(enc.fecha_factura)
            e = {
                'fecha_compra': fecha_compra,
                'proveedor': enc.proveedor,
                'observacion': enc.observacion,
                'no_factura': enc.no_factura,
                'fecha_factura': fecha_factura,
                'sub_total': enc.sub_total,
                'descuento': enc.descuento,
                'total': enc.total
            }

            form_compras = ComprasEncForm(e)
        else:
            det=None

        contexto = {'productos': prod, 'encabezado':enc, 'detalle':det, 'form_enc':form_compras}


    if request.method == 'POST':
        fecha_compra = request.POST.get("fecha_compra")
        observacion = request.POST.get("observacion")
        no_factura = request.POST.get("no_factura")
        fecha_factura = request.POST.get("fecha_factura")
        proveedor = request.POST.get("proveedor")
        subtotal = 0
        descuento = 0
        total = 0

        if not compra_id:
            prov = Proveedor.objects.get(pk=proveedor)

            enc = ComprasEnc(
                fecha_compra = fecha_compra,
                observacion = observacion,
                no_factura = no_factura,
                fecha_factura = fecha_factura,
                proveedor = prov,
                uc = request.user
            )

            #si se crea el encabezado
            if enc: 
                enc.save()
                compra_id = enc.id
        else:
            enc = ComprasEnc.objects.filter(pk=compra_id).first()

            if enc:
                enc.fecha_compra = fecha_compra
                enc.observacion = observacion
                enc.no_factura = no_factura
                enc.fecha_factura  = fecha_factura
                enc.um = request.user.id
                enc.save()
            
        if not compra_id:
            return redirect("cmp:compras_list")

        producto = request.POST.get("id_id_producto")
        cantidad = request.POST.get("id_cantidad_detalle")
        precio = request.POST.get("id_precio_detalle")
        sub_total_detalle = request.POST.get("id_sub_total_detalle")
        descuento_detalle = request.POST.get("id_descuento_detalle")
        total_detalle = request.POST.get("id_total_detalle")

        prod = Producto.objects.get(pk=producto)

        det = ComprasDet(
            compra=enc,
            producto=prod,
            cantidad=cantidad,
            precio_prv=precio,
            descuento=descuento_detalle,
            costo=0,
            uc=request.user
        )

        # si se creo el detalle, lo guardamos
        if det:
            det.save()

            sub_total = ComprasDet.objects.filter(compra=compra_id).aggregate(Sum('sub_total'))
            descuento = ComprasDet.objects.filter(compra=compra_id).aggregate(Sum('descuento'))
            enc.sub_total = sub_total["sub_total__sum"]
            enc.descuento = descuento["descuento__sum"]
            enc.save()

        return redirect("cmp:compras_edit", compra_id=compra_id)
            
    return render(request, template_name, contexto)

class CompraDetDelete(Sin_Privilegios, generic.DeleteView):
    permission_required = "cmp.delete_comprasdet"
    model = ComprasDet
    template_name = "cmp/compras_det_del.html"
    context_object_name ='obj'

    def get_success_url(self):
        compra_id=self.kwargs['compra_id']
        return reverse_lazy('cmp:compras_edit', kwargs={'compra_id':compra_id})


    
    

cmp/templates/cmp/compras_det_del.html
<div class="modal-dialog modal-lg">
    <div class="modal-content">
        <form role="form" action="{% url 'cmp:compras_del' obj.compra.id obj.pk %}" method="post" class="form-inline">
            <div class="col-xl-12 col-md-12 mb-12">
                <div class="card border-left-danger shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                    Eliminar Detalle
                                </div>
                                <div class="dropdown-divider"></div>
                                {% csrf_token %}
                                <div class="row">
                                    ¿Eliminar {{ obj.producto }} de compra número <b>{{ obj.compra_id }}</b>?
                                </div>
                                <div class="dropdown-divider"></div>
                                <div class="row">
                                    <div class="col">
                                        <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span>Si, Eliminar</button>
                                        <button type="button" class="btn btn-success" onclick="return cerrar_modal()">Cancelar</button>
                                    </div>
                                </div>
                            </div>

                            <div class="col-auto">
                                <i class="far fa-calendar-plus fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>

cmp/templates/cmp/compras_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Compras</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                <a class="dropdown-item" href="{% url 'cmp:compras_new' %}"><i class="far fa-calendar-plus"></i>Nueva</a>
                <a class="dropdown-item" href="{% url 'cmp:compras_print_all' %}", target="reportes"><i class="fas fa-print"></i>Listado</a>
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No hay Compras</div>           
       {% endif %}

       <table class="table table-striped table-hover dt-responsive nowrap" style="width: 100%;">
           <thead>
               <th>Id</th>
               <!-- <th>Fecha</th> -->
               <th>Observación</th>
               <th>No. Factura</th>
               <!-- <th>F. Factura</th> -->
               <th>Sub Total</th>
               <th>Descuento</th>    
               <th>Total</th>
               <th>Estado</th>                                      
               <th class="all">Acciones</th>
           </thead>

           <tbody>               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <!-- <td>{{ item.fecha_compra }}</td> -->
                       <td>{{ item.observacion }}</td>
                       <td>{{ item.no_factura }}</td>
                       <!-- <td>{{ item.fecha_factura }}</td> -->
                       <td>{{ item.sub_total }}</td>           
                       <td>{{ item.descuento }}</td>      
                       <td>{{ item.total }}</td>                                         
                       <td>{{ item.estado|yesno:"Activo,Inactivo" }}</td>
                       <td>
                            <a class="btn btn-warning btn-circle" href="{% url 'cmp:compras_edit' item.id %}"><i class="far fa-edit"></i></a>
                            <a class="btn btn-success btn-circle" href="{% url 'cmp:compras_print_one' item.id %}" target="reportes"><i class="fas fa-print"></i></a>
                       </td>
                   </tr>
               {% endfor %}        
           </tbody>
       </table>       

    </div>
</div>

{% endblock page_content %}

{% block js_page %}
<script>
    // llamamos el dataTables jQuery plugin
    $(function() {
        $('.table').DataTable({
            "language": {
                "processing": "Procesando...",
                "lengthMenu": "Mostrar _MENU_ registros",
                "zeroRecords": "No se encontraron resultados",
                "emptyTable": "Ningún dato disponible en esta tabla",
                "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "infoFiltered": "(filtrado de un total de _MAX_ registros)",
                "search": "Buscar:",
                "infoThousands": ",",
                "loadingRecords": "Cargando...",
                "paginate": {
                    "first": "Primero",
                    "last": "Último",
                    "next": "Siguiente",
                    "previous": "Anterior"
                },
                "aria": {
                    "sortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sortDescending": ": Activar para ordenar la columna de manera descendente"
                }
            }
        });
    });
</script>
   
{% endblock js_page %}
    

cmp/templates/cmp/inactivar_proveedor.html
<div class="modal-dialog modal-sm">  
    <div class="modal-content">
        <form method="POST" class="form-inline">
            {% csrf_token %}
            <div class="col">
                <div class="card border-left-danger shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-warning text-uppercase"> 
                                    <div class="alert">
                                        ¿Inactivar: <b> {{ obj.descripcion }}</b> ?
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <button type="button" class="btn btn-danger" id="btnInactivar"><i class="far fa-question-circle"></i>Si, Inactivar</button>
                                <button type="button" class="btn btn-success" onclick="return cerrar_modal()"> No, Cancelar</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>

<script>
    $(document).ready(function(){

        // confirmamos el token de seguridad
        var token = $('input[name="csrfmiddlewaretoken"]').val();
        $.ajaxSetup({
            beforeSend: function(xhr, settings){
                if(!(/^http:.*/.test(settings.url || /^https:.*/.test(settings.url)))){
                    xhr.setRequestHeader("X-CSRFToken", token);
                }
            }
        });

        // hacemos click en el botón inactivar
        $("#btnInactivar").click(function(e){
            e.preventDefault();
            // alert("Probando")

            var id = {{ obj.id }};
            var template = "{% url 'cmp:proveedor_inactivar' obj.id %}";
            // template += id;
            var data = {"id":id};
            data = JSON.stringify(data);

            $.ajax({
                type: "POST",
                url: template,
                data: data,
                beforeSend: function(xhr, settings){
                    $.ajaxSettings.beforeSend(xhr, settings);
                },
                success: function(response){
                    console.log(response);
                    cerrar_modal();
                    // alert(response);
                    var tipo = (response.startsWith('Proveedor no existe') ? 'red':'green')
                    mensaje(response, tipo);
                },
                error: function(jqXHR, textStatus, errorThrow){
                    console.log(textStatus, errorThrow);
                    mensaje(errorThrow, 'red')
                    cerrar_modal();
                }
            });
        });
    });
</script>

cmp/templates/cmp/proveedor_form.html
<div class="modal-dialog modal-lg">  
    <div class="modal-content">
        
        {% if obj %}        
            <form method="POST" role="form" class="form-inline" action="{% url 'cmp:proveedor_edit' obj.pk %}">
        {% else %}
            <form method="POST" role="form" class="form-inline" action="{% url 'cmp:proveedor_new' %}">
        {% endif %}    

            {% csrf_token %}
            <div class="col-xl-12 col-md-12 mb-12">
    
                {% if obj %}
                <div class="card border-left-warning shadow h-100 py-2">
                    {% else %}
                    <div class="card border-left-succes shadow h-100 py-2">
                        {% endif %}
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                        {% if obj %} Editar {% else %} Nuevo {% endif %}Proveedor
                                    </div>
                                    <div class="dropdown-divider"></div>
                                    <div class="row">
                                        {{ form.as_p}}
                                    </div>
    
                                    <!-- {{ form.as_p }} -->
                                    <div class="dropdown-divider"></div>
                                    <div class="row">
                                        <div class="col">
                                            <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span>Guardar</button>
                                            <!-- <a href="{% url 'inv:um_list' %}" class="btn btn-success"><span class="fa fa-undo">Cancelar</span></a> -->
                                            <button type="button" class="btn btn-success" onclick="return cerrar_modal()">Cancelar</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
        </form>
    </div>        
</div>

cmp/templates/cmp/proveedor_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Proveedores</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                    <a class="dropdown-item" onclick="return abrir_modal('{% url 'cmp:proveedor_new' %}')" href="#"> <i class="fa fa-calendar-plus"></i> Nuevo</a>
                    <!-- <a class="dropdown-item" href="#">Another action</a> -->
                <div class="dropdown-divider"></div>
                <!-- <a class="dropdown-item" href="#">Something else here</a> -->
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No hay Proveedores</div>           
       {% endif %}

       <table class="table table-striped table-hover dt-responsive nowrap" style="width: 100%;">
           <thead>
               <th>Id</th>
               <th>Descripción</th>
               <th>Dirección</th>
               <th>Contacto</th>
               <th>Teléfono</th>
               <th>Email</th>
               <th>Estado</th>                                  
               <th class="all">Acciones</th>
           </thead>

           <tbody>               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <td>{{ item.descripcion }}</td>
                       <td>{{ item.direccion }}</td>
                       <td>{{ item.contacto }}</td>
                       <td>{{ item.telefono }}</td>
                       <td>{{ item.email }}</td>                                              
                       <td>{{ item.estado|yesno:"Activo,Inactivo" }}</td>
                       <td>
                            <button class="btn btn-warning btn-circle" onclick="return abrir_modal('{% url 'cmp:proveedor_edit' item.id %}')"><i class="far fa-edit"></i></button>
                            <button class="btn btn-warning btn-circle" onclick="return abrir_modal('{% url 'cmp:proveedor_inactivar' item.id %}')"><i class="far fa-thumbs-down"></i></a>
                       </td>
                   </tr>
               {% endfor %}
                   
           </tbody>
       </table>       

    </div>
</div>

{% endblock page_content %}

{% block js_page %}
<script>
    // llamamos el dataTables jQuery plugin
    $(document).ready(function() {
        $('.table').DataTable();
    });
</script>
   
{% endblock js_page %}
    